﻿// ZDNet.de - Newsticker
// Copyright (c) 2009, CBS interactive GmbH
// Author: Christoph H. Hochstätter
//
// This software may be distributed freely
// Feel free to use the source code for your own purposes
//


var feedTimer; //timeout object for reading RSS
var LOCAL = {};

//
// Main gadget strings
//
LOCAL.feedUrl = 'http://www.zdnet.de/feeds/news/xml/rss_h20.xml.htm';
LOCAL.showcategory = 1;
LOCAL.showdate = 1;

//
// Used in Options
//

function GetGlobalSetting(SettingsName, defaultValue) {
    try {
        System.Gadget.Settings.write(SettingsName, Parameters[0].selectSingleNode(SettingsName).text);
    }
    catch(e) {
        System.Gadget.Settings.write(SettingsName, defaultValue);
    }
}

function ReadGlobalSettings() {
	var xdoc = new ActiveXObject("Microsoft.XMLDOM");
	xdoc.async=false;
	//debugger;
    xdoc.load("http://www.zdnet.de/feeds/vista-sidebar/feeds-zdnet.xml");
    tempvar = System.Gadget.path;
    if ( xdoc.xml == "" ) {
        xdoc.load(tempvar+"\\feeds-zdnet.xml");
    } else {
        xdoc.save(tempvar+"\\feeds-zdnet.xml");    
    }
    
    FeedSources  = [];
    Parameters   = xdoc.selectNodes("/feeds");
    ZDfeeds      = xdoc.selectNodes("/feeds/category");
    
    GetGlobalSetting('prompt', 'Wählen Sie Ihren gewünschen Newsfeed aus:');
    GetGlobalSetting('menucolortext', '#ffffff');
    GetGlobalSetting('menucolorbg', '#aa0000');
    GetGlobalSetting('titlecolor', '#0000C0');
    GetGlobalSetting('categorycolor', '#800000');
    GetGlobalSetting('datecolor', '#000000');
    GetGlobalSetting('fontname', 'Tahoma, Arial, Segoe UI');
    GetGlobalSetting('logourl', 'http://www.zdnet.de');
    GetGlobalSetting('defaultfeed', 'http://www.zdnet.de/feeds/news/xml/rss_h20.xml.htm');
    LOCAL.feedUrl = System.Gadget.Settings.read('defaultfeed');
    System.Gadget.Settings.write('RssUrl', LOCAL.feedUrl);
}

function GetFeedList() {
    for (n=0; n < ZDfeeds.length; n++) {
        FeedSources[n]={};
        FeedSources[n].title = ZDfeeds[n].selectSingleNode('title').text;
        FeedSources[n].link = ZDfeeds[n].selectSingleNode('link').text;
        try {
          FeedSources[n].showcategory = ZDfeeds[n].selectSingleNode('showcategory').text;
        }
        catch(e) {
        }        
        try {
          FeedSources[n].showdate = ZDfeeds[n].selectSingleNode('showdate').text;
        }
        catch(e) {
        }        
    }
}

// ------------------------------
// callback functions and events

//called when the settings window closes
/*function settingsClosed(p_event) {
    if (p_event.closeAction == p_event.Action.commit) { //OK clicked?
        settingsRead();
    }
}*/

// called when the docked state changes
function dockStateChanged() {
	if (System.Gadget.docked) {
		document.body.style.width  = "130px";
        document.getElementById("menu").style.width = "127px";
	} else {
		document.body.style.width  = "230px";
        document.getElementById("menu").style.width = "227px";
	}
	System.Gadget.background   = "bg3.png";
    scrollerInit();
    scrollerStart();
	document.body.style.height = "250px";
}

// called after the RSS file is loaded
function onXmlReturnHandler(xdoc) {

	var n, node, nodes, item;
	feedItems = []; 
    gadgetEl = document.getElementById("gadget");
	if (xdoc.xml != "") {
	    gadgetEl.innerHTML = "";
        gadgetEl.style.fontFamily = GetSetting('fontname', 'Verdana, Tahoma, Arial');
	    nodes = xdoc.selectNodes("/rss/channel/item");
	    for (n=0; n < nodes.length; n++) {
		    node = nodes[n];
		    item = {};
		    item.title = node.selectSingleNode('title').text;
		    item.link = node.selectSingleNode('link').text;
		    try {
		      if (LOCAL.showcategory == 0) Error();
		      item.category = node.selectSingleNode('category').text;
		      gadgetEl.innerHTML += '<span class="category"><font color="'+GetSetting('categorycolor','#C00000')+'">'+item.category+':</font><br/></span>';
		    }
		    catch(ex) {
		    }
		    gadgetEl.innerHTML += '<b><font color="'+GetSetting('titlecolor','#0000C0')+'"><a href="'+item.link+'" target="_blank">'+hesc(item.title)+'</a></font></b>';
		    try {
		        if (LOCAL.showdate == 0) Error();
		        item.pubDate = node.selectSingleNode('pubDate').text;
		        feedItems.push(item);
		        i=item.pubDate.indexOf('+');
		        if (i == -1) i=item.pubDate.indexOf('-');
		        h=item.pubDate.substr(i-9,2);
		        ds2=item.pubDate.substr(i,3);
		        if (h.length == 1) h="0"+h;
		        time=h+item.pubDate.substr(i-7,3);
		        date=item.pubDate.substr(5,11);
		        test=date.substr(10,1);
		        if (test == " ") date=date.substr(0,10);
		        i=date.indexOf(' ');
		        i2=date.lastIndexOf(' ');
		        d=date.substr(0,i);
		        switch (date.substr(i+1,3).toLowerCase()) {
		          case "jan":
		            m="01";
		            break;
		          case "feb":
		            m="02";
		            break;
		          case "mar":
		            m="03";
		            break;
		          case "apr":
		            m="04";
		            break;
		          case "may":
		            m="05";
		            break;
		          case "jun":
		            m="06";
		            break;
		          case "jul":
		            m="07";
		            break;
		          case "aug":
		            m="08";
		            break;
		          case "sep":
		            m="09";
		            break;
		          case "oct":
		            m="10";
		            break;
		          case "nov":
		            m="11";
		            break;
		          case "dec":
		            m="12";
		            break;
		        }
		        y=date.substr(i2+1,4);
		        if (d.length == 1) d="0"+d;
		        gadgetEl.innerHTML += '<br/><span class="date"><font color="'+GetSetting('datecolor','#000000')+'">' + d + '.' + m + '.' + y + ', ' + time + '</font></span>';
	        }
	        catch(ex) {}
 	        gadgetEl.innerHTML += '<hr/>';
	    }
	} else {
	  gadgetEl.innerHTML = '<p align="center"><br/><br/><b>Zur Zeit besteht keine Verbindung zu <a href="http://www.zdnet.de">ZDNet.de</a></b></p>';
	}
	nodes = item = xdoc = null;
	scrollerInit();
	scrollerStart();
	//setup timer to load again
	feedTimer = setTimeout(getFeed, 1000*60*10); //reload again in 10 minutes
}


function getFeed() {
	//shut down feed timer (if running)
	if (feedTimer) {
		clearTimeout(feedTimer);
		feedTimer=null;
	}
	//debugger;
	var xdoc = new ActiveXObject("Microsoft.XMLDOM");
	xdoc.onreadystatechange = function () {
		if ( xdoc.readyState == 4 ) {
			//debugger;
			onXmlReturnHandler(xdoc);
		}
	};
	xdoc.load(LOCAL.feedUrl);
}

function pageUnload() {
    window.detachEvent("onunload", pageUnload);

	if (feedTimer) {
		clearTimeout(feedTimer);
		feedTimer=null;
	}
}

// called when the gadget loads
function pageLoad() {
    currentChannel = 0;
    window.detachEvent("onload", pageLoad);
	window.attachEvent("onunload", pageUnload);
	
	var el, gadgetEl;

	feedItems = []; //setup an empty array for the RSS feed items

	//setup the docked stuff
	System.Gadget.onDock = dockStateChanged;
	System.Gadget.onUndock = dockStateChanged;

	//setup the settings stuff
	//System.Gadget.settingsUI = "settings.html";
	//System.Gadget.onSettingsClosed = settingsClosed;

	pleaseWait();
	ReadGlobalSettings();
	GetFeedList();
	settingsRead();
	dockStateChanged();
	getFeed();
		
	//Can be used to redirect to a URL, when clicking the upper part of the gadget
	//el = document.getElementById("logo");
	//el.style.cursor = "hand";
	//el.onclick = logoclick;

	el = gadgetEl = null;
}

function LoadCurrentChannel() {
  System.Gadget.Settings.write("RssUrl", FeedSources[currentChannel].link);
  System.Gadget.Settings.write("showcategory", FeedSources[currentChannel].showcategory);
  System.Gadget.Settings.write("showdate", FeedSources[currentChannel].showdate);
  settingsRead();
}

function nextchannel() {
  currentChannel = (currentChannel+1)%ZDfeeds.length;
  LoadCurrentChannel();
}

function prevchannel() {
  currentChannel = (currentChannel+ZDfeeds.length-1)%ZDfeeds.length;
  LoadCurrentChannel();
}

function logoclick() {
  System.Shell.execute(System.Gadget.Settings.read('logourl'));
}

function pleaseWait() {
    gadgetEl = document.getElementById("gadget"); //get the container
    gadgetEl.innerHTML = '<p align="center"><br/><br/><b>Ihr Ticker wird geladen, bitte warten ...</b></p>';
}

// ------------------------------
// global functions

//escape an HTML string
function hesc(p_str) {
    return p_str.replace(/&/g,"&amp;").replace(/</g, "&lt;").replace(/>/g,"&gt;").replace(/\"/g,"&quot;");
}

function GetSetting(SettingsName, defaultValue) {
    var temp;
    temp = System.Gadget.Settings.read(SettingsName);
    x=temp.toString();
    if (!x) temp = defaultValue;
    return temp;
}

function settingsRead() {
	LOCAL.feedUrl = GetSetting("RssUrl", "http://www.zdnet.de/feeds/news/xml/rss_h20.xml.htm");
	LOCAL.showcategory = GetSetting("showcategory", 1);
	LOCAL.showdate = GetSetting("showdate", 1);
	//skip on gadget initialization
	if (feedTimer) {
	    pleaseWait();
		clearTimeout(feedTimer);
		feedTimer = setTimeout(getFeed, 0); //reload again in an X hours
	}
    ChannelEl = document.getElementById("menu");
    ChannelEl.style.backgroundColor = System.Gadget.Settings.read('menucolorbg');
    ChannelEl.style.color = System.Gadget.Settings.read('menucolortext');
    ChannelEl = document.getElementById("menuitem");
    ChannelEl.innerHTML = FeedSources[currentChannel].title;
}


// SCROLLING ------------------------------------------------------------


var scroller={};

function scrollerInit() {
	scroller.contH=187;
	scroller.scrollAreaH=187;

	scroller.ref=document.getElementById("Scroller");
	scroller.areaRef=document.getElementById("ScrollArea");
	scroller.itemsRef=document.getElementById("gadget");
	scroller.containerRef=document.getElementById("Container");	

	scroller.areaRef.onclick=function(e) {
		e=fixE(e);
		if (!e.srcElement || e.srcElement.id != "ScrollArea")
			return;

		var newPos=within(e.layerY - scroller.scrollH/2, 0, scroller.scrollAreaH - scroller.scrollH - 1);
		scrollTo(newPos);
	}

	scroller.ref.onDrag=function(x,y) {
		var scrollY=parseInt(scroller.ref.style.top);
		var docY=0-(scrollY * (scroller.docH - scroller.contH) / scroller.scrollDist);
		scroller.itemsRef.style.top=docY + "px";
	}
}

function scrollerStart() {
	scroller.docH=scroller.containerRef.offsetHeight;
	scroller.scrollH=(scroller.contH * scroller.scrollAreaH) / scroller.docH;
	scroller.ref.style.height=Math.round(scroller.scrollH) + "px";
	scroller.scrollDist=Math.round(scroller.scrollAreaH-scroller.scrollH);
	scrollTo(0);
	Dragger.init(scroller.ref,0,0,0,scroller.scrollDist-2);
}

function scroll(direction) {
	var newPos=Math.round(parseInt(scroller.ref.style.top) + scroller.scrollH*direction - 4);
	newPos=within(newPos, 0, scroller.scrollAreaH - scroller.scrollH - 1);
	scrollTo(newPos);
}

function scrollTo(y) {
	scroller.ref.style.top=y + "px";
	scroller.ref.onDrag(0, y);
}

// DRAGGING ------------------------------------------------------------

var Dragger = {

	obj : null,

	init : function(o, minX, maxX, minY, maxY) {

		o.onmousedown=Dragger.start;
		o.root=o; 
		o.minX=minX;
		o.minY=minY;
		o.maxX=maxX;
		o.maxY=maxY;
		
		if (isNaN(parseInt(o.root.style.left))) 
			o.root.style.left="0px";
		if (isNaN(parseInt(o.root.style.top))) 
			o.root.style.top="0px";
		
		o.root.onDragStart=new Function();
		o.root.onDragEnd=new Function();

	},

	start : function(e) {
		var o=Dragger.obj=this;
		e=fixE(e);
		
		var y=parseInt(o.root.style.top);
		var x=parseInt(o.root.style.left);
		
		o.root.onDragStart(x, y);
		o.lastMouseX=e.clientX;
		o.lastMouseY=e.clientY;

		if (o.minX != null)	
			o.minMouseX=e.clientX - x + o.minX;
		if (o.maxX != null)	
			o.maxMouseX=o.minMouseX + o.maxX - o.minX;
		if (o.minY != null)	
			o.minMouseY=e.clientY - y + o.minY;
		if (o.maxY != null)	
			o.maxMouseY=o.minMouseY + o.maxY - o.minY;
		
		document.onmousemove=Dragger.drag;
		document.onmouseup=Dragger.end;

		return false;
	},

	drag : function(e) {
		
		e=fixE(e);
		var o=Dragger.obj;

		var ey=e.clientY;
		var ex=e.clientX;
		var y=parseInt(o.root.style.top);
		var x=parseInt(o.root.style.left);
		var nx, ny;

		if (o.minX != null) 
			ex=Math.max(ex, o.minMouseX);
		if (o.maxX != null) 
			ex=Math.min(ex, o.maxMouseX);
		if (o.minY != null)
			ey=Math.max(ey, o.minMouseY);
		if (o.maxY != null) 
			ey=Math.min(ey, o.maxMouseY);

		nx=x + (ex - o.lastMouseX);
		ny=y + (ey - o.lastMouseY);

		Dragger.obj.root.style["left"] = nx + "px";
		Dragger.obj.root.style["top"] = ny + "px";
		Dragger.obj.lastMouseX	= ex;
		Dragger.obj.lastMouseY	= ey;

		Dragger.obj.root.onDrag(nx, ny);
		
		return false;
	},

	end : function() {
		document.onmousemove=null;
		document.onmouseup=null;
		Dragger.obj.root.onDragEnd(parseInt(Dragger.obj.root.style["left"]), parseInt(Dragger .obj.root.style["top"]));
		Dragger.obj=null;
	}

};

// HTML Lib -----------------------------------------------------------

function getDiv(id, doc) {
	return ((doc == null) ? document : doc).getElementById(id);
}

function getHtml(id, doc) {
	var div=getDiv(id, doc);
	if (div == null)
		return null;
	return div.innerHTML;
}

function setHtml(id, html, doc) {
	var div=getDiv(id, doc);
	if (div == null)
		return;
	div.innerHTML=html;
}

function showhide(id, hide) {
	var div=getDiv(id);
	if (div == null)
		return null;

	div.style.visibility=(hide) ? "hidden" : "visible";	
}

function fixE(e) {
	if (typeof e == 'undefined') 
		e=window.event;

	if (typeof e.layerX == 'undefined') 
		e.layerX=e.offsetX;
	if (typeof e.layerY == 'undefined') 
		e.layerY=e.offsetY;
			
	return e;
}

function within(i, min, max) {
	i=Math.max(i, min);
	i=Math.min(i, max);
	return i;
}



// ------------------------------
// this gets everything started after the DOM is created
window.attachEvent("onload", pageLoad);
